
// PIC16F886 Configuration Bit Settings

// 'C' source line config statements

// CONFIG1
#pragma config FOSC = INTRC_NOCLKOUT// Oscillator Selection bits (INTOSCIO oscillator: I/O function on RA6/OSC2/CLKOUT pin, I/O function on RA7/OSC1/CLKIN)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled and can be enabled by SWDTEN bit of the WDTCON register)
#pragma config PWRTE = OFF      // Power-up Timer Enable bit (PWRT disabled)
#pragma config MCLRE = ON       // RE3/MCLR pin function select bit (RE3/MCLR pin function is MCLR)
#pragma config CP = OFF         // Code Protection bit (Program memory code protection is disabled)
#pragma config CPD = OFF        // Data Code Protection bit (Data memory code protection is disabled)
#pragma config BOREN = OFF      // Brown Out Reset Selection bits (BOR disabled)
#pragma config IESO = OFF       // Internal External Switchover bit (Internal/External Switchover mode is disabled)
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enabled bit (Fail-Safe Clock Monitor is disabled)
#pragma config LVP = OFF        // Low Voltage Programming Enable bit (RB3 pin has digital I/O, HV on MCLR must be used for programming)

// CONFIG2
#pragma config BOR4V = BOR40V   // Brown-out Reset Selection bit (Brown-out Reset set to 4.0V)
#pragma config WRT = OFF        // Flash Program Memory Self Write Enable bits (Write protection off)

// #pragma config statements should precede project file includes.
// Use project enums instead of #define for ON and OFF.

#include <xc.h>



#define LED1 RC0
#define LED2 RC1
#define LED3 RC2
#define LED4 RC3
#define LED5 RC4
#define LED6 RC5
#define LED7 RC6
#define LED8 RC7

#define PB8	RB0
#define PB7	RB1
#define PB6	RB2
#define PB5	RB3
#define PB4	RB4
#define PB3	RB5
#define PB2	RB6
#define PB1	RB7

#define BUZZER RA5

#define _XTAL_FREQ 4000000

void setup() {
    PORTA = 0;
    PORTB = 0;
    PORTC = 0;
    TRISA = 0b00001111;
    TRISB = 0b11111111;
    TRISC = 0;
    OSCCON = 0b01100000;
    ANSEL = 0b00001111;
    ANSELH = 0;

}

void check_system() {
    PORTC = 0b11111111;
    BUZZER = 1;
    __delay_ms(1000);
    BUZZER = 0;
    PORTC = 0;
}

void buzz() {
    for (int i =0; i<10; i++){
    BUZZER = 1;
    __delay_ms(50);
    BUZZER = 0;
    __delay_ms(100);
    }  
  
}

void main(void) {
    setup();
    check_system();
    while (1) {
        if (PB1 == 0) {
            LED1 = 1;
            buzz();
            

            for (int counter = 0; counter < 20; counter++) {
                LED1 = 1;
                __delay_ms(100);
                LED1 = 0;
                __delay_ms(100);
            }
        }

        if (PB2 == 0) {
            LED2 = 1;
           buzz();

            for (int counter = 0; counter < 20; counter++) {
                LED2 = 1;
                __delay_ms(100);
                LED2 = 0;
                __delay_ms(100);
            }
        }

        if (PB3 == 0) {
            LED3 = 1;
          buzz();

            for (int counter = 0; counter < 20; counter++) {
                LED3 = 1;
                __delay_ms(100);
                LED3 = 0;
                __delay_ms(100);
            }
        }

        if (PB4 == 0) {
            LED4 = 1;
           buzz();

            for (int counter = 0; counter < 20; counter++) {
                LED4 = 1;
                __delay_ms(100);
                LED4 = 0;
                __delay_ms(100);
            }
        }

        if (PB5 == 0) {
            LED5 = 1;
           buzz();

            for (int counter = 0; counter < 20; counter++) {
                LED5 = 1;
                __delay_ms(100);
                LED5 = 0;
                __delay_ms(100);
            }
        }

        if (PB6 == 0) {
            LED6 = 1;
           buzz();

            for (int counter = 0; counter < 20; counter++) {
                LED6 = 1;
                __delay_ms(100);
                LED6 = 0;
                __delay_ms(100);
            }
        }

        if (PB7 == 0) {
            LED7 = 1;
           buzz();

            for (int counter = 0; counter < 20; counter++) {
                LED7 = 1;
                __delay_ms(100);
                LED7 = 0;
                __delay_ms(100);
            }
        }

        if (PB8 == 0) {
            LED8 = 1;
           buzz();

            for (int counter = 0; counter < 20; counter++) {
                LED8 = 1;
                __delay_ms(100);
                LED8 = 0;
                __delay_ms(100);
            }
        }
    }
}
